#include <bits/stdc++.h>
using namespace std;

#define int long long

struct dr {
    int x;
    int plus = 0;
};

vector<dr> tre;

void push(int v) {
    tre[v * 2].x += tre[v].plus;
    tre[v * 2 + 1].x += tre[v].plus;
    tre[v * 2 + 1].plus += tre[v].plus;
    tre[v * 2].plus += tre[v].plus;
    tre[v].plus = 0;
}

void build(int v, int l, int r) {
    if (l == r) {
        tre[v].x = l;
        return;
    }
    int m = (l + r) / 2;
    build(v * 2, l, m);
    build(v * 2 + 1, m + 1, r);
    tre[v].x = min(tre[v * 2].x, tre[v * 2 + 1].x);
}

void upd(int v, int l, int r, int tl, int tr) {
    if (tl > r || tr < l) return;
    if (tl >= l && tr <= r) {
        tre[v].x--;
        tre[v].plus--;
        return;
    }
    push(v);
    int tm = (tl + tr) / 2;
    upd(v * 2, l, r, tl, tm);
    upd(v * 2 + 1, l, r, tm + 1, tr);
    tre[v].x = min(tre[v * 2].x, tre[v * 2 + 1].x);
}

int spusk(int v, int l, int r, int id) {
    if (l == r) return l;
    int m = (l + r) / 2;
    push(v);
    if (tre[v * 2 + 1].x <= id) return spusk(v * 2 + 1, m + 1, r, id);
    return spusk(v * 2, l, m, id);
}

int cum(int v, int l, int r, int id) {
    if (l == r) return tre[v].x;
    int m = (l + r) / 2;
    push(v);
    if (id <= m) {
        return cum(v * 2, l, m, id);
    }return cum(v * 2 + 1, m + 1, r, id);

}

vector<int> p;
vector<int> sz;
vector<deque<int>> a, b;
vector<deque<int>> vnosa, vnosb;
vector<deque<int>> lna, lnb;
vector<int> ans;
vector<int> ansrev;

int get(int v) {
    if (p[v] == v) return v;
    return p[v] = get(p[v]);
}

void upd(int v, int u) {
    v = get(v);
    u = get(u);
    int pos = spusk(1, 0, sz.size() - 1, cum(1, 0, sz.size() - 1, v));
    upd(1, pos + 1, sz.size() - 1, 0, sz.size() - 1);
    bool ok = false;
    int lenrev = 0;
    int vnosrev = 0;
    while (!a[u].empty()) {
        if (a[v].back() > a[u].front()) {
            lna[v].back() += lna[u].front();
            vnosa[v].back() += vnosa[u].front();
            if (!(a[u].size() == 1)) {
                lenrev += lna[u].front();
                vnosrev += vnosa[u].front();
            }
        } else {
            ansrev[v] = 0;
            ans[v] += a[v].back() * lna[v].back() - vnosa[v].back();
            a[v].push_back(a[u].front());
            vnosa[v].push_back(vnosa[u].front());
            lna[v].push_back(lna[u].front());
            ok = true;
        }
        lna[u].pop_front();
        vnosa[u].pop_front();
        a[u].pop_front();
    }
    ansrev[v] = ansrev[u];
    if (ok) {
        b[v].clear();
        vnosb[v].clear();
        lnb[v].clear();
        while (!b[u].empty()) {
            ansrev[v] += b[u].front() * lnb[u].front() - vnosb[u].front();
            b[v].push_back(b[u].front());
            vnosb[v].push_back(vnosb[u].front());
            lnb[v].push_back(lnb[u].front());
            vnosb[u].pop_front();
            b[u].pop_front();
            lnb[u].pop_front();
        }
    } else {
        lnb[u].back() += lenrev;
        vnosb[u].back() += vnosrev;
        while (!b[v].empty()) {
            if (b[u].back() > b[v].front()) {
                lnb[u].back() += lnb[v].front();
                vnosb[u].back() += vnosb[v].front();
            } else {
                ansrev[v] += b[u].back() * lnb[u].back() - vnosb[u].back();
                b[u].push_back(b[v].front());
                vnosb[u].push_back(vnosb[v].front());
                lnb[u].push_back(lnb[v].front());
            }
            b[v].pop_front();
            lnb[v].pop_front();
            vnosb[v].pop_front();
        }
        ansrev[v] += b[u].back() * lnb[u].back() - vnosb[u].back();
        b[v] = b[u];
        vnosb[v] = vnosb[u];
        lnb[v] = lnb[u];
    }
    sz[v] += sz[u];
    p[u] = v;
}


signed  main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n;
    cin >> n;
    vector<int> h(n);
    tre.resize(4 * n);
    a.resize(n);
    b.resize(n);
    p.resize(n);
    sz.resize(n, 1);
    vnosa.resize(n);
    vnosb.resize(n);
    lnb.resize(n);
    lna.resize(n);
    ans.resize(n);
    ansrev.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> h[i];
        a[i].push_back(h[i]);
        b[i].push_back(h[i]);
        p[i] = i;
        vnosa[i].push_back(h[i]);
        vnosb[i].push_back(h[i]);
        lna[i].push_back(1);
        lnb[i].push_back(1);
    }
    build(1, 0, sz.size() - 1);
    for (int i = 0; i < n - 1; i++) {
        int k;
        cin >> k;
        k--;
        int v = spusk(1, 0, sz.size() - 1, k);
        int u = spusk(1, 0, sz.size() - 1, k + 1);
        upd(v, u);
        cout << ans[get(v)] + ansrev[get(v)] << "\n";
    }
}