#include <bits/stdc++.h>
using namespace std;

#define int long long

struct dr {
    int x;
    int plus = 0;
    int st = -1;
};



vector<int> p;
vector<int> sz;
vector<deque<int>> a, b;
vector<deque<int>> vnosa, vnosb;
vector<deque<int>> lna, lnb;
vector<int> ans;
vector<int> ansrev;
vector<int> group;

int get(int v) {
    if (p[v] == v) return v;
    return p[v] = get(p[v]);
}

void upd(int v, int u) {
    v = get(v);
    u = get(u);
    bool ok = false;
    int lenrev = 0;
    int vnosrev = 0;
    while (!a[u].empty()) {
        if (a[v].back() > a[u].front()) {
            lna[v].back() += lna[u].front();
            vnosa[v].back() += vnosa[u].front();
            if (!(a[u].size() == 1)) {
                lenrev += lna[u].front();
                vnosrev += vnosa[u].front();
            }
        } else {
            ansrev[v] = 0;
            ans[v] += a[v].back() * lna[v].back() - vnosa[v].back();
            a[v].push_back(a[u].front());
            vnosa[v].push_back(vnosa[u].front());
            lna[v].push_back(lna[u].front());
            ok = true;
        }
        lna[u].pop_front();
        vnosa[u].pop_front();
        a[u].pop_front();
    }
    ansrev[v] = ansrev[u];
    if (ok) {
        b[v] = b[u];
        vnosb[v] = vnosb[u];
        lnb[v] = lnb[u];
    } else {
        lnb[u].back() += lenrev;
        vnosb[u].back() += vnosrev;
        while (!b[v].empty()) {
            if (b[u].back() > b[v].front()) {
                lnb[u].back() += lnb[v].front();
                vnosb[u].back() += vnosb[v].front();
            } else {
                ansrev[v] += b[u].back() * lnb[u].back() - vnosb[u].back();
                b[u].push_back(b[v].front());
                vnosb[u].push_back(vnosb[v].front());
                lnb[u].push_back(lnb[v].front());
            }
            b[v].pop_front();
            lnb[v].pop_front();
            vnosb[v].pop_front();
        }
        b[v] = b[u];
        vnosb[v] = vnosb[u];
        lnb[v] = lnb[u];
    }
    sz[v] += sz[u];
    p[u] = v;
}


signed  main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n;
    cin >> n;
    vector<int> h(n);
    a.resize(n);
    b.resize(n);
    p.resize(n);
    sz.resize(n, 1);
    vnosa.resize(n);
    vnosb.resize(n);
    lnb.resize(n);
    lna.resize(n);
    ans.resize(n);
    ansrev.resize(n);
    group.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> h[i];
        a[i].push_back(h[i]);
        b[i].push_back(h[i]);
        p[i] = i;
        vnosa[i].push_back(h[i]);
        vnosb[i].push_back(h[i]);
        lna[i].push_back(1);
        lnb[i].push_back(1);
        group[i] = i;
    }
    for (int i = 0; i < n - 1; i++) {
        int k;
        cin >> k;
        k--;
        int v = 0, u = 0;
        for (int j = 0; j < n; j++) {
            if (group[get(j)] == k) {
                v = j;
            }
            if (group[get(j)] == k + 1) {
                u = j;
            }
        }
        upd(v, u);
        cout << ans[get(v)] + ansrev[get(v)] << "\n";
        group[u] = group[v];
        for (int j = 0; j < n; j++) {
            if (group[get(j)] >= k + 1 && j == get(j)) {
                group[get(j)]--;
            }
        }
    }
}