#include <bits/stdc++.h>
using namespace std;

#define int long long

struct dr {
    int x;
    int plus = 0;
};

vector<dr> tre;

void push(int v) {
    tre[v * 2].x += tre[v].plus;
    tre[v * 2 + 1].x += tre[v].plus;
    tre[v * 2 + 1].plus += tre[v].plus;
    tre[v * 2].plus += tre[v].plus;
    tre[v].plus = 0;
}

void build(int v, int l, int r) {
    if (l == r) {
        tre[v].x = l;
        return;
    }
    int m = (l + r) / 2;
    build(v * 2, l, m);
    build(v * 2 + 1, m + 1, r);
    tre[v].x = min(tre[v * 2].x, tre[v * 2 + 1].x);
}

void upd(int v, int l, int r, int tl, int tr) {
    if (tl > r || tr < l) return;
    if (tl >= l && tr <= r) {
        tre[v].x--;
        tre[v].plus--;
        return;
    }
    push(v);
    int tm = (tl + tr) / 2;
    upd(v * 2, l, r, tl, tm);
    upd(v * 2 + 1, l, r, tm + 1, tr);
    tre[v].x = min(tre[v * 2].x, tre[v * 2 + 1].x);
}

int spusk(int v, int l, int r, int id) {
    if (l == r) return l;
    int m = (l + r) / 2;
    push(v);
    if (tre[v * 2 + 1].x <= id) return spusk(v * 2 + 1, m + 1, r, id);
    return spusk(v * 2, l, m, id);
}




vector<int> p;
vector<int> sz;
vector<deque<int>> a, b;
vector<deque<int>> vnosa, vnosb;
vector<deque<int>> lna, lnb;
vector<int> ans;
vector<int> ansrev;

int get(int v) {
    if (p[v] == v) return v;
    return p[v] = get(p[v]);
}

void upd(int v, int u) {
    v = get(v);
    u = get(u);
    bool ok = false;
    int lenrev = 0;
    int vnosrev = 0;
    if (sz[v] < sz[u]) {
        while (!a[u].empty()) {
            if (a[v].back() > a[u].front()) {
                lna[v].back() += lna[u].front();
                vnosa[v].back() += vnosa[u].front();
                if (!(a[u].size() == 1)) {
                    lenrev += lna[u].front();
                    vnosrev += vnosa[u].front();
                }
            } else {
                ansrev[v] = 0;
                ans[v] += a[v].back() * lna[v].back() - vnosa[v].back();
                a[v].push_back(a[u].front());
                vnosa[v].push_back(vnosa[u].front());
                lna[v].push_back(lna[u].front());
                ok = true;
            }
            lna[u].pop_front();
            vnosa[u].pop_front();
            a[u].pop_front();
        }
        ansrev[v] = ansrev[u];
        if (ok) {
            b[v] = b[u];
            vnosb[v] = vnosb[u];
            lnb[v] = lnb[u];
        } else {
            lnb[u].back() += lenrev;
            vnosb[u].back() += vnosrev;
            while (!b[v].empty()) {
                if (b[u].back() > b[v].front()) {
                    lnb[u].back() += lnb[v].front();
                    vnosb[u].back() += vnosb[v].front();
                } else {
                    ansrev[v] += b[u].back() * lnb[u].back() - vnosb[u].back();
                    b[u].push_back(b[v].front());
                    vnosb[u].push_back(vnosb[v].front());
                    lnb[u].push_back(lnb[v].front());
                }
                b[v].pop_front();
                lnb[v].pop_front();
                vnosb[v].pop_front();
            }
            b[v] = b[u];
            vnosb[v] = vnosb[u];
            lnb[v] = lnb[u];
        }
        sz[v] += sz[u];
        p[u] = v;
    } else {
        while (!a[v].empty() && !a[u].empty()) {
            if (a[v].back() > a[u].front()) {
                lna[v].back() += lna[u].front();
                vnosa[v].back() += vnosa[u].front();
                if (!(a[u].size() == 1)) {
                    lenrev += lna[u].front();
                    vnosrev += vnosa[u].front();
                    ans[u] -= a[u].front() * lna[u].front() - vnosa[u].front();
                }
                lna[u].pop_front();
                vnosa[u].pop_front();
                a[u].pop_front();
            } else {
                ans[u] += a[v].back() * lna[v].back() - vnosa[v].back();
                ok = true;
                lna[u].push_front(lna[v].back());
                vnosa[u].push_front(vnosa[v].back());
                a[u].push_front(a[v].back());
                lna[v].pop_back();
                vnosa[v].pop_back();
                a[v].pop_back();
            }
        }
            while (!a[v].empty()) {
                if (a[v].size() != 1) {
                    ans[u] += a[v].front() * lna[v].front() - vnosa[v].front();
                }
                lna[u].push_back(lna[v].front());
                a[u].push_back(a[v].front());
                vnosa[u].push_back(vnosa[v].front());
                lna[v].pop_front();
                a[v].pop_front();
                vnosa[v].pop_front();
            }


        if (!ok) {
            lnb[u].back() += lenrev;
            vnosb[u].back() += vnosrev;
            while (!b[v].empty()) {
                if (b[u].back() > b[v].front()) {
                    lnb[u].back() += lnb[v].front();
                    vnosb[u].back() += vnosb[v].front();
                } else {
                    ansrev[u] += b[u].back() * lnb[u].back() - vnosb[u].back();
                    b[u].push_back(b[v].front());
                    vnosb[u].push_back(vnosb[v].front());
                    lnb[u].push_back(lnb[v].front());
                }
                b[v].pop_front();
                lnb[v].pop_front();
                vnosb[v].pop_front();
            }
        }
        sz[u] += sz[v];
        p[v] = u;
    }
}


signed  main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n;
    cin >> n;
    vector<int> h(n);
    a.resize(n);
    b.resize(n);
    p.resize(n);
    sz.resize(n, 1);
    vnosa.resize(n);
    vnosb.resize(n);
    lnb.resize(n);
    lna.resize(n);
    ans.resize(n);
    ansrev.resize(n);
    tre.resize(4 * n);
    for (int i = 0; i < n; i++) {
        cin >> h[i];
        a[i].push_back(h[i]);
        b[i].push_back(h[i]);
        p[i] = i;
        vnosa[i].push_back(h[i]);
        vnosb[i].push_back(h[i]);
        lna[i].push_back(1);
        lnb[i].push_back(1);
    }
    build(1, 0, n - 1);
    for (int i = 0; i < n - 1; i++) {
        int k;
        cin >> k;
        k--;
        int v = spusk(1, 0, n - 1, k);
        int u = spusk(1, 0, n - 1, k + 1);
        upd(v, u);
        upd(1, v + 1, n - 1, 0, n - 1);
        cout << ans[get(v)] + ansrev[get(v)] << "\n";
    }
}