#include <bits/stdc++.h>

using namespace std;

#define int long long

// #pragma GCC optimize("O3,Ofast,unroll-loops")
// #pragma GCC target("avx2")

constexpr int MOD = 1e9 + 7;

vector<vector<bool>> pole;
vector<vector<bool>> used;
int cur = 0;
int k;
int cnt = 0;

void obr(int x, int y) {
    used[x][y] = true;
    if (x == 0 && y == 0) {
        cnt += (cur == k);
        used[x][y] = false;
        return;
    }
    cur += pole[x][y];
    if (x && (!used[x - 1][y] || (x - 1 == 0 && y == 0))) {
        obr(x - 1, y);
    }
    if (y && (!used[x][y - 1] || (x == 0 && y - 1 == 0))) {
        obr(x, y - 1);
    }
    used[x][y] = false;
    cur -= pole[x][y];
}

void rec(int x, int y) {
    used[x][y] = true;
    if (x == pole.size() - 1 && y == pole[0].size() - 1) {
        obr(x, y);
        used[x][y] = false;
        if (pole[x][y]) {
            cur--;
        }
        return;
    }
    if (pole[x][y]) {
        cur++;
    }
    if (x == pole.size() - 1) {
        rec(x, y + 1);
    } else if (y == pole[0].size() - 1) {
        rec(x + 1, y);
    } else {
        rec(x + 1, y);
        rec(x, y + 1);
    }
    used[x][y] = false;
    cur -= pole[x][y];
}

signed  main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    cin >> k;
    pole.resize(n, vector<bool>(m));
    used.resize(n, vector<bool>(m));
    for (int i = 0; i < k; i++) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        pole[x][y] = true;
    }
    rec(0, 0);
    cout << cnt;
}